//Book.java

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.data.*;
import com.ms.wfc.data.ui.*;
import com.ms.wfc.io.*;

public class Book extends Form
{
    
	// Variables
	String CurrentDirectory = new String();
    String vrecordset = new String();	
	Image imag;
	File fil ;
	// Navigation, Connection and Recordset
	Connection m_con;
    Recordset m_rs;
    // Search By Word, Connection and Recordset	
	Connection m_con_word;
	Recordset m_rs_word;
	// Search By Address, Connection and Recordset
	Connection m_con_search;
    Recordset m_rs_address;
	    
    protected void finalize()
    {
        try
        {
            m_rs.close();
            m_con.close();
        }
        catch (Exception e)
        {
            handleADOException( e );
        }
    }

    public void dispose()
    {
        super.dispose();
        components.dispose();
    }
	
    public Book()
    {
        // Required for Visual J++ Form Designer support
        initForm();
        
        this.show();
        this.update();

		// Disable contols
		Set_Tab_Panel(false);
		
		// Current dirctory
        CurrentDirectory = fil.getCurrentDirectory();
		 
        //TODO: Add any constructor code after initForm call
        try
        {
            // Procedures ...
			openDataConnection();
			openConnection_search();
			openRecordset_search_word();
			
			// enable
			Set_Tab_Panel(true);
			
			// Initial
			m_rs.moveFirst();
	        m_rs.move(2);
	        CalculValue(); 
	        SetButtons(true);
            pictureBox1.setImage(imag.loadImage(fil.open(String.valueOf(CurrentDirectory.toString() + "\\Pic\\forum.gif"))));
			pictureBox2.setImage(imag.loadImage(fil.open(String.valueOf(CurrentDirectory.toString() + "\\Pic\\Christus-th.gif"))));
        }
        catch (Exception e)
        {
            handleADOException( e );
        }
    }    

	public void btnClose_Click(Object sender, Event evt)
    {
        this.close();
    }
	
	public void formClose(Event e)
    {
		this.close();
    } 
    

    void openDataConnection()
    {
        m_con = new Connection();
        m_rs = new Recordset();
        m_con.setConnectionString ("PROVIDER=Microsoft.Jet.OLEDB.3.51;Data Source=" + CurrentDirectory.toString() + "\\Pic\\KJV.mdb");  
        m_con.setCursorLocation (AdoEnums.CursorLocation.CLIENT);
        m_con.open();
        m_rs.setActiveConnection(m_con);
        m_rs.setSource("select Book, BookTitle, Chapter, Verse, TextData from BibleTable");
        m_rs.setCursorType(AdoEnums.CursorType.STATIC);
        m_rs.setCursorLocation(AdoEnums.CursorLocation.CLIENT);
        m_rs.setLockType(AdoEnums.LockType.OPTIMISTIC);
        m_rs.open();
        
    }
    
	// Procedure - Search operation, connection   
    void openConnection_search()
    {
        m_con_search = new Connection();       
        m_con_search.setConnectionString ("PROVIDER=Microsoft.Jet.OLEDB.3.51;Data Source=" + CurrentDirectory.toString() + "\\Pic\\KJV.mdb");  
        m_con_search.setCursorLocation (AdoEnums.CursorLocation.CLIENT);
        m_con_search.open();
	}
	
	// Procedure - Search operation by word, recordset   
    void openRecordset_search_word()
    {
		m_con_word = new Connection();       
        m_con_word.setConnectionString ("PROVIDER=Microsoft.Jet.OLEDB.3.51;Data Source=" + CurrentDirectory.toString() + "\\Pic\\KJV.mdb");  
        m_con_word.setCursorLocation (AdoEnums.CursorLocation.CLIENT);
        m_con_word.open();
        m_rs_word = new  Recordset();        
        m_rs_word.setActiveConnection(m_con_word);
        m_rs_word.setSource("select BookTitle, Book, Chapter, Verse, TextData from BibleTable");
        m_rs_word.setCursorType(AdoEnums.CursorType.STATIC);
        m_rs_word.setCursorLocation(AdoEnums.CursorLocation.CLIENT);
        m_rs_word.setLockType(AdoEnums.LockType.OPTIMISTIC);
        m_rs_word.open();
       
    }	
	
	// Procedure - Search operation by address, recordset  
    void openRecordset_search_address(String recordset_command)
	{	
		m_rs_address = new  Recordset();
        m_rs_address.setActiveConnection(m_con_search);
        m_rs_address.setSource(recordset_command.toString());
        m_rs_address.setCursorType(AdoEnums.CursorType.STATIC);
        m_rs_address.setCursorLocation(AdoEnums.CursorLocation.CLIENT);
        m_rs_address.setLockType(AdoEnums.LockType.OPTIMISTIC);
        m_rs_address.open();
       
    }
    
    void handleADOException(Exception e)
    {
        e.printStackTrace();
        MessageBox.show( e.toString(), "Book" );
    }
	
    // >>>>>>>>>>>> Navigation Controls >>>>>>>>>>>> 
     // 1- Navogation operation
	// Navigation control 
    public void btnFirst_click(Object source, Event e)
    {
	    m_rs.moveFirst();
	    m_rs.move(2);
	    CalculValue(); 
	    SetButtons(true); 
    }
 
    // Navigation control 
    public void btnPrevious_click(Object source, Event e)
    {
	   m_rs.movePrevious();
	   CalculValue();

	   if (m_rs.getRecordCount() > 0 && editBook.getText().equals("01") && editChapter.getText().equals("001") && editVerse.getText().equals("001"))
	   
	      SetButtons(true);	   
	   else
	      SetButtonsAll(true);
    }
 
    // Navigation control 
    public void btnNext_click(Object source, Event e)
    {
	   m_rs.moveNext();
	   CalculValue();
	   if (m_rs.getRecordCount() > 0 && editBook.getText().equals("66") && editChapter.getText().equals("001") && editVerse.getText().equals("001"))
	   
	      SetButtons(false);
	   else
	       SetButtonsAll(true);
    }

    // Navigation control 
    public void btnLast_click(Object source, Event e)
    {
	    m_rs.moveLast();
	    CalculValue();
	    SetButtons(false);
    }

    // Procedure - Book, BookTitle, Chapter and Verse Values
    void CalculValue()
    {
	    editBook.setText(m_rs.getField("Book").getString());
		editBookTitle.setText(m_rs.getField("BookTitle").getString());
		editChapter.setText(m_rs.getField("Chapter").getString());
		editVerse.setText(m_rs.getField("Verse").getString());
		editTextData.setText(m_rs.getField("TextData").getString());
		lbposition.setText("Rec: " + String.valueOf(m_rs.getAbsolutePosition()).toString());
  
    }
 
   // Procedure - Enable or disable navigation controls
   void SetButtons(boolean bVal)
   {
	   btnFirst.setEnabled(!bVal);
	   btnPrevious.setEnabled(!bVal);
	   btnNext.setEnabled(bVal);
	   btnLast.setEnabled(bVal);
   }
 
   // Enable or disable navigation controls
   void SetButtonsAll(boolean bVal)
   {
	   btnFirst.setEnabled(bVal);
	   btnPrevious.setEnabled(bVal);
	   btnNext.setEnabled(bVal);
	   btnLast.setEnabled(bVal);
   }
   
   // Enable or disable these controls
    void Set_Tab_Panel(boolean bVal)
   {
	    panel1.setEnabled(bVal);
		panel2.setEnabled(bVal);
		tabControl1.setEnabled(bVal);
	}
   // <<<<<<<<<<<< Navigation Controls <<<<<<<
   
   // >>>>>>>>>>>>>>>> Search By Word >>>>>>>>	
	  // 2- Search Operations by word....	
   	
    public void btnDisplay_click(Object source, Event e)
    {
		// Variables
		String  upperword, lowerword, leftword, rightword, ulword;
		String vtextdata, vbook, vtitle, vchapter, vverse;
		// ListView Subitems variables
		String[] subitems = new String[4];
		int recordno = 0;
		int i = 0;
		int j = 0;
				
				
		// Display this message
		lbInfo.setText("One moment ...");
		 
		//Set the btnDisplay button disable
        btnDisplay.setEnabled(false);
		
		// Uppercase style  - exemple: WORD
		upperword = editWord.getText().toString().toUpperCase();				   
	
		//Lowercase  style - example: word
		lowerword = editWord.getText().toString().toLowerCase(); 
			
		//Uppercase + lowercase  style - example: Word
	    // 1st chararcter - W
		leftword = editWord.getText().substring(0,1);
	    // Others characters - ord
		rightword =	editWord.getText().substring(1);
		ulword = leftword.toUpperCase() + rightword.toLowerCase();
		
		//The view selected is Report
		i = 0;		
		m_rs_word.move(2);		
		
		//Max items to found, less then 5000 
		while (!m_rs_word.getEOF() && i < 5000)
		{
	        // Use RichEdit control to store TextData field
			richEdit1.setText(m_rs_word.getField("TextData").getString());
			
			// Search by word, for this use the Find function of the RichEdit control
			if ( (richEdit1.find(lowerword.toString()) != -1) && (richEdit1.find(upperword.toString()) != -1) && (richEdit1.find(ulword.toString()) != -1))
			{ 	        
		        // Absolute position of the record
				recordno = m_rs_word.getAbsolutePosition();
               
				// Book field value	        	
				vbook  = m_rs_word.getField("Book").getString().toString();

		      	 //Title field value				
				 vtitle = m_rs_word.getField("BookTitle").getString().toString();
	
		    	 //Chapter field value				
				 vchapter = m_rs_word.getField("Chapter").getString().toString();

				 //Verse field value
				 vverse = m_rs_word.getField("Verse").getString().toString();	
				              
				 // ListView Control
				 // Values of Subitems
				 subitems[0] = vbook.toString().toString(); 
				 subitems[1] = vtitle.toString(); 
				 subitems[2] = vchapter.toString();
				 subitems[3]= vverse.toString();
				 
				 listViewSearch.insertItem(i,String.valueOf(recordno).toString(),0,subitems );
				
				 i = i + 1;
				 
				 // Number of item(s) found
				 j = i-1;
			}
			m_rs_word.moveNext();
		}

		//Information about Items found	
		if (i < 1)
			lbInfo.setText( "0 item found.");
		else
		{
		   if (j >= 4999)
			  lbInfo.setText( "More then " + String.valueOf(j + 1).toString() + " items found."); 
		   else
			   lbInfo.setText( String.valueOf(j + 1).toString() + " items found."); 
		}		   
	 }

     public void editWord_textChanged(Object source, Event e)
	
	 {
		if (editWord.getText().length()>0)
		{	
		    // Set the btnDisplay control enebled
			btnDisplay.setEnabled(true);
			
			// lbinfo control value
		   lbInfo.setText("Search operation ...");
		   
		   // Clear the listView control
		   listViewSearch.clear();
		   		   		   
		   // Add header columns
		   listViewSearch.addColumn("Record",70,1,0);
		   listViewSearch.addColumn("Bk",30,2,0);
		   listViewSearch.addColumn("Title",85,3,0);
		   listViewSearch.addColumn("Chp",45,4,0);
		   listViewSearch.addColumn("Verse",45,5,0);		      
		}   
	 }
  
    public void listViewSearch_mouseUp(Object source, MouseEvent e)
    
	 {
		String itemselected  = new String();
		int itemindex;
	 
		//Value of the item selected 
		itemselected = listViewSearch.getItemText(listViewSearch.getFocusedItem().getIndex());
        itemindex = Integer.valueOf(itemselected.toString()).intValue();
     
		//Display the record corresponding to the item selected
		itemindex = itemindex - 1;
		if (itemindex > 1)
	    {	
			m_rs.moveFirst();
			m_rs.move(itemindex);
		    CalculValue();
			
			if (itemindex == 31103)
		       SetButtons(false);	       
		    else
	        {
		       if (itemindex == 2)
			     SetButtons(true);
		      else
	   	         SetButtonsAll(true);
			}
		}
	
    }

    
    public void listViewSearch_keypress(Object source, KeyEvent e)
    {
	    String itemselected  = new String();
		int itemindex;
	 
		//Value of the item selected 
		itemselected = listViewSearch.getItemText(listViewSearch.getFocusedItem().getIndex());
        itemindex = Integer.valueOf(itemselected.toString()).intValue();
    
		//Display the record corresponding to the item selected
		itemindex = itemindex - 1;
		if (itemindex > 1)
	    {	
			m_rs.moveFirst();
			m_rs.move(itemindex);
		    CalculValue();
			
			if (itemindex == 31103)
		       SetButtons(false);	       
		    else
	        {
		       if (itemindex == 2)
			     SetButtons(true);
		      else
	   	         SetButtonsAll(true);
			}
		}
	
    }
	//<<<<<<<<<<<<<<<< Search By Word <<<<<<<<<
	
 
 // >>>>>>>>>>>>>>>>> Search By Address >>>>>>
 // 3- Search Operations by address....	
 public void tabControl1_mouseUp(Object source, MouseEvent e)
 {  
	// Tabpage no 0, by Word
    if (String.valueOf(tabControl1.getSelectedIndex()).toString().equals( "0"))
    {
       lbInfo.setText("Search operation ..."); 
	}	 
	else	
	{	 
		// Tabpage no 1, By Address
		if (String.valueOf(tabControl1.getSelectedIndex()).toString().equals( "1"))
		{  
		    lbInfo1.setText("One moment ...");
		
			//Clear the comboboxes		
			comboBook.removeAll();
			comboTitle.removeAll(); 
			comboChapter.removeAll();
			comboVerse.removeAll();
	
        
			// Recordset declaration
			vrecordset = "select Book, BookTitle, Chapter, Verse from BibleTable where (BibleTable.Chapter = '001' and BibleTable.Verse = '001') or ( BibleTable.Book = '" + editBook.getText().toString() + "' and ( BibleTable.Chapter = '" + editChapter.getText().toString() + "' or BibleTable.Verse = '001'))";
			openRecordset_search_address(vrecordset.toString());
     
			//Comboboxes values 
			Searchbyaddress();
			
			// Message
			lbInfo1.setText("Search operation..."); 
		} 
	}
 }
 
 //Comboboxes values 
 void Searchbyaddress()
 {
	    // Varaiables
	    String vtextdata, vbook, vtitle, vchapter, vverse;
     
	 	//Clear the comboboxes		
		comboBook.removeAll();
		comboTitle.removeAll(); 
		comboChapter.removeAll();
        comboVerse.removeAll();
	 
        // Search Operation 	 
    	m_rs_address.moveFirst();

		while (!m_rs_address.getEOF())
		{			
			 //Values of Book, Title, Chapter and Verse fields
			 vbook  = m_rs_address.getField("Book").getString().toString();
			 vtitle = m_rs_address.getField("BookTitle").getString().toString();  
             vchapter = m_rs_address.getField("Chapter").getString().toString();
             vverse  = m_rs_address.getField("Verse").getString().toString();

			if (!vbook.toString().equals(editBook.getText().toString()))
			{
				if ((vchapter.toString().equals("001")) && (vverse.toString().equals("001")))   		  
				{	
					//Add item to combobook and combotitle comboboxes
					comboBook.addItem(vbook.toString());
					comboTitle.addItem(vtitle.toString());			
		    	}
			}	
			else
			{
				if ((vchapter.toString().equals("001")) && (vverse.toString().equals("001")))   		  
				{				
						//Add item to combobook and combotitle comboboxes
					comboBook.addItem(vbook.toString());
					comboTitle.addItem(vtitle.toString());				
				}	

				if (!vchapter.toString().equals(editChapter.getText().toString()))
				{
					if (vverse.toString().equals("001"))
					{
						//Add item to combochapter and combochapterrecno comboboxes
						comboChapter.addItem(vchapter.toString());						 
					}
				}
				else
				{
					if  (vverse.toString().equals("001"))		 				  
					{
						//Add item to combochapter and comboverse comboboxes
				    	comboChapter.addItem(vchapter.toString());
						comboVerse.addItem(vverse.toString());							
					}	
					else
					{
						//Add item to comboverse and comboverserecno comboboxes					    	
						comboVerse.addItem(vverse.toString());			
							
					}
				}
			}
			m_rs_address.moveNext();
    	}  
		
        //Current string Values display at the Comboboxes
    	int varcount = comboBook.getItemCount();
	    for( int i = 0; i < varcount; ++i )
	    {
	       if (comboBook.getItem(i).toString().equals(editBook.getText().toString()))
		   {						 
	           comboBook.setSelectedIndex(i);
		       comboTitle.setSelectedIndex(i);
           }
	    }
    
        varcount = comboChapter.getItemCount();
	    for(int i = 0; i < varcount; ++i )
	    {      
	       if (comboChapter.getItem(i).toString().equals(editChapter.getText().toString()))
	           comboChapter.setSelectedIndex(i);
        }
	  
   	    varcount = comboVerse.getItemCount();
	    for( int i  = 0; i < varcount; ++i )
	    {
           if (comboVerse.getItem(i).toString().equals(editVerse.getText().toString()))
	           comboVerse.setSelectedIndex(i);
        }
	    	
 }	 
	 
 public void comboTitle_selectedIndexChanged(Object source, Event e)
 {
     // Variables
	 String vcombtitle = new String();
     int recordno = 0;
   
      // selected item Value of the combotitle  	 
	  vcombtitle = comboTitle.getSelectedItem().toString();


       // Record data boxes, data corresponding 
	   m_rs_word.moveFirst();
	   while (!m_rs_word.getEOF())
	   {
	         if (m_rs_word.getField("BookTitle").getString().toString().equals(vcombtitle.toString()) && m_rs_word.getField("Chapter").getString().toString().equals("001") && m_rs_word.getField("Verse").getString().toString().equals("001"))
			 {
				recordno = m_rs_word.getAbsolutePosition()-1;
				
				// Modify, Record data boxes
				m_rs.moveFirst();
		        m_rs.move(recordno);
	            CalculValue();

				// Navigation control
				if (recordno == 31103)
				   SetButtons(false);	       
				else
				{
				   if (recordno == 2)
					  SetButtons(true);
				   else
				      SetButtonsAll(true);
			 	}
							
				break; 
			 }	 
	         m_rs_word.moveNext();
	   }
	 
	   // Search (Title), data corresponding 
	   
	  // Recordset declaration
	  vrecordset = "select Book, BookTitle, Chapter, Verse from BibleTable where (BibleTable.Chapter = '001' and BibleTable.Verse = '001') or ( BibleTable.BookTitle = '" + vcombtitle.toString() + "' and ( BibleTable.Chapter = '001' or BibleTable.Verse = '001'))";
	  openRecordset_search_address(vrecordset.toString());
	  
	  //Comboboxes values 
	  Searchbyaddress();
 }
  

 public void comboBook_selectedIndexChanged(Object source, Event e)
 {
	  // Variables
	 String vcombbook = new String();  
     int recordno = 0;
   
      // selected item Value of the combobook 	 
	  vcombbook = comboBook.getSelectedItem().toString();


       // Record data boxes, data corresponding 
	   m_rs_word.moveFirst();
	   while (!m_rs_word.getEOF())
	   {
	         if (m_rs_word.getField("Book").getString().toString().equals(vcombbook.toString()) && m_rs_word.getField("Chapter").getString().toString().equals("001") && m_rs_word.getField("Verse").getString().toString().equals("001"))
			 {
				recordno = m_rs_word.getAbsolutePosition()-1;
				
				// Modify, Record data boxes
				m_rs.moveFirst();
		        m_rs.move(recordno);
	            CalculValue();

				// Navigation control
				if (recordno == 31103)
				   SetButtons(false);	       
				else
				{
				   if (recordno == 2)
					  SetButtons(true);
				   else
				      SetButtonsAll(true);
			 	}
							
				break; 
			 }	 
	         m_rs_word.moveNext();
	   }
	 
	   // Search (Book), data corresponding 
	   
	  // Recordset declaration
	  vrecordset = "select Book, BookTitle, Chapter, Verse from BibleTable where (BibleTable.Chapter = '001' and BibleTable.Verse = '001') or ( BibleTable.Book = '" + vcombbook.toString() + "' and ( BibleTable.Chapter = '001' or BibleTable.Verse = '001'))";
	  openRecordset_search_address(vrecordset.toString());
	  
	  //Comboboxes values 
	  Searchbyaddress();
 }

 public void comboChapter_selectedIndexChanged(Object source, Event e)
 {
	  // Variables
	  String vcombbook = new String();
	  String vcombchapter = new String();
	  String vtextdata, vbook, vchapter, vverse;
      int recordno = 0;
   
      // selected item Value of the combobook 	 
	  vcombbook = comboBook.getText().toString();
	  vcombchapter = comboChapter.getSelectedItem().toString();


      // Record data boxes, data corresponding 
	  m_rs_word.moveFirst();
	  while (!m_rs_word.getEOF())
	  {
	        if (m_rs_word.getField("Book").getString().toString().equals(vcombbook.toString()) && m_rs_word.getField("Chapter").getString().toString().equals(vcombchapter.toString()) && m_rs_word.getField("Verse").getString().toString().equals("001"))
	    	 {
				recordno = m_rs_word.getAbsolutePosition()-1;
				
				// Modify, Record data boxes
				m_rs.moveFirst();
		        m_rs.move(recordno);
	            CalculValue();

				// Navigation control
				if (recordno == 31103)
				   SetButtons(false);	       
				else
				{
				   if (recordno == 2)
					  SetButtons(true);
				   else
				      SetButtonsAll(true);
			 	}
							
				break; 
			 }	 
	         m_rs_word.moveNext();
	   }
	 
	   // Search by address (Chapter), data corresponding 
	   
	   // Recordset declaration
	   vrecordset = "select Book, BookTitle, Chapter, Verse from BibleTable where (BibleTable.Chapter = '001' and BibleTable.Verse = '001') or ( BibleTable.Book = '" + vcombbook.toString() + "' and ( BibleTable.Chapter = '" + vcombchapter + "' or BibleTable.Verse = '001'))";
	   openRecordset_search_address(vrecordset.toString());
	  
	   //Clear the combobox		
	   comboVerse.removeAll();
	 
       // Search Operation, chapter 	 
       m_rs_address.moveFirst();

	   while (!m_rs_address.getEOF())
	   {			
			 //Values of Book, Chapter and Verse fields
			 vbook  = m_rs_address.getField("Book").getString().toString();			
             vchapter = m_rs_address.getField("Chapter").getString().toString();
             vverse  = m_rs_address.getField("Verse").getString().toString();

			if (vbook.toString().equals(vcombbook.toString()) && vchapter.toString().equals(vcombchapter.toString()))
			{  
				comboVerse.addItem(vverse.toString());							
			}	
			
			m_rs_address.moveNext();
    	}  
		comboVerse.setSelectedIndex(0);	    	
 }	 
 
 

 public void comboVerse_selectedIndexChanged(Object source, Event e)
 {
	 // Variables
	  String vcombbook = new String();
	  String vcombchapter = new String();
	  String vcombverse = new String();
      int recordno = 0;
   
      // selected item Value of the combobook 	 
	  vcombbook = comboBook.getText().toString();
	  vcombchapter = comboChapter.getText().toString();
	  vcombverse = comboVerse.getSelectedItem().toString();


      // Record data boxes, data corresponding 
	  m_rs_word.moveFirst();
	  while (!m_rs_word.getEOF())
	  {
	        if (m_rs_word.getField("Book").getString().toString().equals(vcombbook.toString()) && m_rs_word.getField("Chapter").getString().toString().equals(vcombchapter.toString()) && m_rs_word.getField("Verse").getString().toString().equals(vcombverse.toString()))
	    	 {
				recordno = m_rs_word.getAbsolutePosition()-1;
				
				// Modify, Record data boxes
				m_rs.moveFirst();
		        m_rs.move(recordno);
	            CalculValue();

				// Navigation control
				if (recordno == 31103)
				   SetButtons(false);	       
				else
				{
				   if (recordno == 2)
					  SetButtons(true);
				   else
				      SetButtonsAll(true);
			 	}
							
				break; 
			 }	 
	         m_rs_word.moveNext();
	   }
 }

  // <<<<<<<<<<<<<<<<< Search By Address <<<<,,	
	
 

    /**
    * NOTE: The following code is required by the Visual J++ form
    * designer.  It can be modified using the form editor.  Do not
    * modify it using the code editor.
    */
 Container components = new Container();
 Label labelBook = new Label();
 Edit editBook = new Edit();
 Label labelBookTitle = new Label();
 Edit editBookTitle = new Edit();
 Label labelChapter = new Label();
 Edit editChapter = new Edit();
 Label labelVerse = new Label();
 Edit editVerse = new Edit();
 PictureBox pictureBox1 = new PictureBox();
 Edit editTextData = new Edit();
 Button btnClose = new Button();
 Panel panel1 = new Panel(components);
 Label label2 = new Label();
 GroupBox groupBox1 = new GroupBox();
 PictureBox pictureBox2 = new PictureBox();
 Label label3 = new Label();
 TabControl tabControl1 = new TabControl();
 TabPage tabPage1 = new TabPage();
 GroupBox groupBox3 = new GroupBox();
 TabPage tabPage2 = new TabPage();
 GroupBox groupBox4 = new GroupBox();
 Panel panel2 = new Panel(components);
 Label lbposition = new Label();
 Button btnFirst = new Button();
 Button btnPrevious = new Button();
 Button btnNext = new Button();
 Button btnLast = new Button();
 ComboBox comboTitle = new ComboBox();
 ComboBox comboBook = new ComboBox();
 ComboBox comboChapter = new ComboBox();
 ComboBox comboVerse = new ComboBox();
 Label label11 = new Label();
 Label label10 = new Label();
 Label label9 = new Label();
 Label label8 = new Label();
 Label lbInfo1 = new Label();
 Label lbInfo = new Label();
 ListView listViewSearch = new ListView();
 Edit editWord = new Edit();
 Label label5 = new Label();
 Button btnDisplay = new Button();
 RichEdit richEdit1 = new RichEdit();

 private void initForm()
 {
	 this.setLocation(new Point(7, 7));
	 this.setText("Book");
	 this.setAutoScaleBaseSize(13);
	 this.setAutoScroll(true);
	 this.setBorderStyle(FormBorderStyle.SIZABLE_TOOLWINDOW);
	 this.setClientSize(new Point(681, 492));
	 this.setStartPosition(FormStartPosition.CENTER_SCREEN);

	 labelBook.setBackColor(Color.CONTROL);
	 labelBook.setLocation(new Point(8, 280));
	 labelBook.setSize(new Point(48, 15));
	 labelBook.setTabIndex(5);
	 labelBook.setTabStop(false);
	 labelBook.setText("Book");

	 editBook.setAnchor(ControlAnchor.TOPLEFTRIGHT);
	 editBook.setBackColor(Color.CONTROL);
	 editBook.setLocation(new Point(56, 272));
	 editBook.setSize(new Point(60, 20));
	 editBook.setTabIndex(6);
	 editBook.setText("");
	 editBook.setMultiline(true);
	 editBook.setReadOnly(true);

	 labelBookTitle.setBackColor(Color.CONTROL);
	 labelBookTitle.setLocation(new Point(136, 280));
	 labelBookTitle.setSize(new Point(48, 15));
	 labelBookTitle.setTabIndex(8);
	 labelBookTitle.setTabStop(false);
	 labelBookTitle.setText("BookTitle");

	 editBookTitle.setAnchor(ControlAnchor.TOPLEFTRIGHT);
	 editBookTitle.setBackColor(Color.CONTROL);
	 editBookTitle.setLocation(new Point(184, 272));
	 editBookTitle.setSize(new Point(124, 20));
	 editBookTitle.setTabIndex(9);
	 editBookTitle.setText("");
	 editBookTitle.setMultiline(true);
	 editBookTitle.setReadOnly(true);

	 labelChapter.setBackColor(Color.CONTROL);
	 labelChapter.setLocation(new Point(8, 304));
	 labelChapter.setSize(new Point(48, 15));
	 labelChapter.setTabIndex(10);
	 labelChapter.setTabStop(false);
	 labelChapter.setText("Chapter");

	 editChapter.setAnchor(ControlAnchor.TOPLEFTRIGHT);
	 editChapter.setBackColor(Color.CONTROL);
	 editChapter.setLocation(new Point(56, 296));
	 editChapter.setSize(new Point(60, 20));
	 editChapter.setTabIndex(11);
	 editChapter.setText("");
	 editChapter.setMultiline(true);
	 editChapter.setReadOnly(true);

	 labelVerse.setBackColor(Color.CONTROL);
	 labelVerse.setLocation(new Point(136, 304));
	 labelVerse.setSize(new Point(48, 15));
	 labelVerse.setTabIndex(12);
	 labelVerse.setTabStop(false);
	 labelVerse.setText("Verse");

	 editVerse.setAnchor(ControlAnchor.TOPLEFTRIGHT);
	 editVerse.setBackColor(Color.CONTROL);
	 editVerse.setLocation(new Point(184, 296));
	 editVerse.setSize(new Point(124, 20));
	 editVerse.setTabIndex(13);
	 editVerse.setText("");
	 editVerse.setMultiline(true);
	 editVerse.setReadOnly(true);

	 pictureBox1.setLocation(new Point(72, 24));
	 pictureBox1.setSize(new Point(184, 200));
	 pictureBox1.setTabIndex(1);
	 pictureBox1.setTabStop(false);
	 pictureBox1.setText("pictureBox1");

	 editTextData.setAnchor(ControlAnchor.TOPLEFTRIGHT);
	 editTextData.setBackColor(Color.CONTROL);
	 editTextData.setLocation(new Point(8, 336));
	 editTextData.setSize(new Point(300, 96));
	 editTextData.setTabIndex(14);
	 editTextData.setText("");
	 editTextData.setMultiline(true);
	 editTextData.setReadOnly(true);
	 editTextData.setScrollBars(ScrollBars.VERTICAL);

	 btnClose.setSize(new Point(48, 30));
	 btnClose.setTabIndex(0);
	 btnClose.setText("&Close");
	 btnClose.addOnClick(new EventHandler(this.btnClose_Click));

	 panel1.setLocation(new Point(256, 448));
	 panel1.setSize(new Point(48, 32));
	 panel1.setTabIndex(15);
	 panel1.setText("");

	 label2.setFont(new Font("Times New Roman", 10.0f, FontSize.POINTS, FontWeight.BOLD, true, true, false, CharacterSet.DEFAULT, 0));
	 label2.setLocation(new Point(8, 240));
	 label2.setSize(new Point(136, 16));
	 label2.setTabIndex(16);
	 label2.setTabStop(false);
	 label2.setText("Record data boxes ...");

	 groupBox1.setBackColor(Color.CONTROLDARK);
	 groupBox1.setLocation(new Point(328, -8));
	 groupBox1.setSize(new Point(16, 496));
	 groupBox1.setTabIndex(17);
	 groupBox1.setTabStop(false);
	 groupBox1.setText("");

	 pictureBox2.setLocation(new Point(400, 24));
	 pictureBox2.setSize(new Point(224, 200));
	 pictureBox2.setTabIndex(2);
	 pictureBox2.setTabStop(false);
	 pictureBox2.setText("pictureBox2");

	 label3.setFont(new Font("Times New Roman", 10.0f, FontSize.POINTS, FontWeight.BOLD, true, true, false, CharacterSet.DEFAULT, 0));
	 label3.setLocation(new Point(360, 248));
	 label3.setSize(new Point(100, 16));
	 label3.setTabIndex(4);
	 label3.setTabStop(false);
	 label3.setText("Search ...");

	 tabControl1.setLocation(new Point(352, 272));
	 tabControl1.setSize(new Point(320, 208));
	 tabControl1.setTabIndex(0);
	 tabControl1.setText("tabControl1");
	 tabControl1.setItemSize(new Point(100, 21));
	 tabControl1.setMultiline(true);
	 tabControl1.setSelectedIndex(0);
	 tabControl1.addOnMouseUp(new MouseEventHandler(this.tabControl1_mouseUp));

	 tabPage1.setLocation(new Point(4, 25));
	 tabPage1.setSize(new Point(312, 179));
	 tabPage1.setTabIndex(0);
	 tabPage1.setText("           By Word           ");
	 tabPage1.setToolTipText(null);

	 groupBox3.setFont(new Font("Courier New", 10.0f, FontSize.POINTS, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
	 groupBox3.setSize(new Point(312, 180));
	 groupBox3.setTabIndex(0);
	 groupBox3.setTabStop(false);
	 groupBox3.setText("");

	 tabPage2.setLocation(new Point(4, 25));
	 tabPage2.setSize(new Point(312, 179));
	 tabPage2.setTabIndex(1);
	 tabPage2.setText("            By address        ");
	 tabPage2.setToolTipText(null);

	 groupBox4.setSize(new Point(312, 176));
	 groupBox4.setTabIndex(0);
	 groupBox4.setTabStop(false);
	 groupBox4.setText("");

	 panel2.setLocation(new Point(8, 448));
	 panel2.setSize(new Point(240, 32));
	 panel2.setTabIndex(7);
	 panel2.setText("");

	 lbposition.setLocation(new Point(8, 8));
	 lbposition.setSize(new Point(56, 16));
	 lbposition.setTabIndex(4);
	 lbposition.setTabStop(false);
	 lbposition.setText("Record");

	 btnFirst.setLocation(new Point(72, 0));
	 btnFirst.setSize(new Point(40, 30));
	 btnFirst.setTabIndex(0);
	 btnFirst.setText("First");
	 btnFirst.addOnClick(new EventHandler(this.btnFirst_click));

	 btnPrevious.setLocation(new Point(112, 0));
	 btnPrevious.setSize(new Point(40, 30));
	 btnPrevious.setTabIndex(1);
	 btnPrevious.setText("Prev.");
	 btnPrevious.addOnClick(new EventHandler(this.btnPrevious_click));

	 btnNext.setLocation(new Point(160, 0));
	 btnNext.setSize(new Point(40, 30));
	 btnNext.setTabIndex(2);
	 btnNext.setText("Next");
	 btnNext.addOnClick(new EventHandler(this.btnNext_click));

	 btnLast.setLocation(new Point(200, 0));
	 btnLast.setSize(new Point(40, 30));
	 btnLast.setTabIndex(3);
	 btnLast.setText("Last");
	 btnLast.addOnClick(new EventHandler(this.btnLast_click));

	 comboTitle.setLocation(new Point(112, 32));
	 comboTitle.setSize(new Point(128, 21));
	 comboTitle.setTabIndex(1);
	 comboTitle.setText("");
	 comboTitle.addOnSelectedIndexChanged(new EventHandler(this.comboTitle_selectedIndexChanged));

	 comboBook.setLocation(new Point(112, 64));
	 comboBook.setSize(new Point(128, 21));
	 comboBook.setTabIndex(2);
	 comboBook.setText("");
	 comboBook.addOnSelectedIndexChanged(new EventHandler(this.comboBook_selectedIndexChanged));

	 comboChapter.setLocation(new Point(112, 96));
	 comboChapter.setSize(new Point(128, 21));
	 comboChapter.setTabIndex(3);
	 comboChapter.setText("");
	 comboChapter.addOnSelectedIndexChanged(new EventHandler(this.comboChapter_selectedIndexChanged));

	 comboVerse.setLocation(new Point(112, 128));
	 comboVerse.setSize(new Point(128, 21));
	 comboVerse.setTabIndex(4);
	 comboVerse.setText("");
	 comboVerse.addOnSelectedIndexChanged(new EventHandler(this.comboVerse_selectedIndexChanged));

	 label11.setLocation(new Point(56, 136));
	 label11.setSize(new Point(48, 15));
	 label11.setTabIndex(5);
	 label11.setTabStop(false);
	 label11.setText("Verse :");

	 label10.setLocation(new Point(56, 104));
	 label10.setSize(new Point(48, 15));
	 label10.setTabIndex(7);
	 label10.setTabStop(false);
	 label10.setText("Chapter :");

	 label9.setLocation(new Point(56, 72));
	 label9.setSize(new Point(48, 15));
	 label9.setTabIndex(8);
	 label9.setTabStop(false);
	 label9.setText("Book :");

	 label8.setLocation(new Point(56, 40));
	 label8.setSize(new Point(48, 15));
	 label8.setTabIndex(6);
	 label8.setTabStop(false);
	 label8.setText("Title :");

	 lbInfo1.setLocation(new Point(16, 160));
	 lbInfo1.setSize(new Point(275, 14));
	 lbInfo1.setTabIndex(0);
	 lbInfo1.setTabStop(false);
	 lbInfo1.setText("");

	 lbInfo.setFont(new Font("MS Sans Serif", 8.0f, FontSize.POINTS, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
	 lbInfo.setLocation(new Point(8, 168));
	 lbInfo.setSize(new Point(288, 14));
	 lbInfo.setTabIndex(1);
	 lbInfo.setTabStop(false);
	 lbInfo.setText("");

	 listViewSearch.setFont(new Font("MS Sans Serif", 8.0f, FontSize.POINTS, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
	 listViewSearch.setLocation(new Point(8, 48));
	 listViewSearch.setSize(new Point(296, 117));
	 listViewSearch.setTabIndex(0);
	 listViewSearch.setText("listView1");
	 listViewSearch.setMultiSelect(false);
	 listViewSearch.setView(ViewEnum.REPORT);
	 listViewSearch.addOnKeyPress(new KeyEventHandler(this.listViewSearch_keypress));
	 listViewSearch.addOnMouseUp(new MouseEventHandler(this.listViewSearch_mouseUp));

	 editWord.setFont(new Font("MS Sans Serif", 8.0f, FontSize.POINTS, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
	 editWord.setLocation(new Point(8, 24));
	 editWord.setSize(new Point(176, 20));
	 editWord.setTabIndex(3);
	 editWord.setText("");
	 editWord.addOnTextChanged(new EventHandler(this.editWord_textChanged));

	 label5.setFont(new Font("Times New Roman", 9.0f, FontSize.POINTS, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
	 label5.setLocation(new Point(8, 8));
	 label5.setSize(new Point(184, 14));
	 label5.setTabIndex(4);
	 label5.setTabStop(false);
	 label5.setText("Type in the word to search for :");

	 btnDisplay.setEnabled(false);
	 btnDisplay.setFont(new Font("MS Sans Serif", 8.0f, FontSize.POINTS, FontWeight.NORMAL, false, false, false, CharacterSet.DEFAULT, 0));
	 btnDisplay.setLocation(new Point(200, 24));
	 btnDisplay.setSize(new Point(88, 23));
	 btnDisplay.setTabIndex(2);
	 btnDisplay.setText("Display");
	 btnDisplay.addOnClick(new EventHandler(this.btnDisplay_click));

	 richEdit1.setFont(Font.DEFAULT_GUI);
	 richEdit1.setForeColor(Color.WINDOWTEXT);
	 richEdit1.setLocation(new Point(560, 232));
	 richEdit1.setSize(new Point(100, 30));
	 richEdit1.setTabIndex(3);
	 richEdit1.setText("");
	 richEdit1.setVisible(false);

	 this.setNewControls(new Control[] {
						 richEdit1, 
						 panel2, 
						 tabControl1, 
						 label3, 
						 pictureBox2, 
						 groupBox1, 
						 label2, 
						 pictureBox1, 
						 panel1, 
						 labelBook, 
						 editBook, 
						 labelBookTitle, 
						 editBookTitle, 
						 labelChapter, 
						 editChapter, 
						 labelVerse, 
						 editVerse, 
						 editTextData});
	 panel1.setNewControls(new Control[] {
						   btnClose});
	 tabControl1.setNewControls(new Control[] {
								tabPage1, 
								tabPage2});
	 tabPage1.setNewControls(new Control[] {
							 groupBox3});
	 groupBox3.setNewControls(new Control[] {
							  btnDisplay, 
							  label5, 
							  editWord, 
							  listViewSearch, 
							  lbInfo});
	 tabPage2.setNewControls(new Control[] {
							 groupBox4});
	 groupBox4.setNewControls(new Control[] {
							  lbInfo1, 
							  label8, 
							  label9, 
							  label10, 
							  label11, 
							  comboVerse, 
							  comboChapter, 
							  comboBook, 
							  comboTitle});
	 panel2.setNewControls(new Control[] {
						   btnLast, 
						   btnNext, 
						   btnPrevious, 
						   btnFirst, 
						   lbposition});
 }
    //NOTE: End of form designer support code.

    /**
    * The main entry point for the application.
    *
    * @param args Array of parameters passed to the application
    * via the command line.
    */
    public static void main(String args[])
    {
        Application.run( new Book() );
    }
}
